# FIX_OFFPAGES-TEST.TCL
#----------------------
set script FIX_OFFPAGES.TCL
set target_prop_name {NAME}

    set dowego 0; # make sure the While execute only once, we need a while because we use break to exit
    #define some NULL constant and place holdere
    set lNullObj NULL
    set varNullObj NULL 
    set lStatus [DboState]
    #Get design and schematic object
    set lDesign [GetActivePMDesign]

    set lSchematicIter [$lDesign NewViewsIter $lStatus $::IterDefs_SCHEMATICS]

    #get the first schematic view
    set lView [$lSchematicIter NextView $lStatus]
    
    #dynamic cast from DboView to DboSchematic
    set lSchematic [DboViewToDboSchematic $lView]
    set lName [DboTclHelper_sMakeCString]

    #placeholder: do your processing on schematic pages
    #set iterative mode ?
    set lPagesIter [$lSchematic NewPagesIter $lStatus]

    #get the first page object
    set lPage [$lPagesIter NextPage $lStatus]

    #set a page counter
    set page_count 0
    set total_inst 0
     
    #iterate thru all pages using a while
    while {$lPage!=$lNullObj} {
         #update page counter
         set page_count [expr $page_count + 1]
         
         #get and display page name in CString format
         $lPage GetName $lName
         set lName_str [DboTclHelper_sGetConstCharPtr $lName]
         puts "\n>>> Page: $lName_str <<<\n-----------------------"

         #placeholder: do your processing on $lPage
         set lOffpgInstsIter [$lPage NewOffPageConnectorsIter $lStatus]
         
         #get the first offpage part inst
         set lInst [$lOffpgInstsIter NextOffPageConnector  $lStatus]
         #
         #iterate thru all instances
         set inst_cnt 0
         while {$lInst!=$lNullObj} {
             incr inst_cnt
             
             set onlyonce 0
             while { $onlyonce == 0 } {
                #this while is use only as an easy way to exit from error condition using a break
                #it must loop only once or less if error
                set onlyonce 1
                #Get offpage source symbol
                set lPropSymbNameCStr [DboTclHelper_sMakeCString "Source Symbol"]
                set lPrpValueCStr [DboTclHelper_sMakeCString]
                set $lStatus [$lInst GetEffectivePropStringValue $lPropSymbNameCStr  $lPrpValueCStr]
                if {[$lStatus OK] == 1} {
                    #succes getting Source Symbol property value
                    #convert value in normal string and force upper case
                    set symbolname_string [string toupper [DboTclHelper_sGetConstCharPtr $lPrpValueCStr]]
                    if {-1 != [string first "OFFPAGE" $symbolname_string]} {
                        #symbole is a valid offpage

                        # Get rotation and mirror state of the instance offpage
                        set symb_rotation [$lInst GetRotation $lStatus]
                        set symb_mirror [$lInst GetMirror $lStatus]
                        
                        #Get instance name en CString et normal string
                        set lNetSymbolName [DboTclHelper_sMakeCString]
                        $lInst GetName $lNetSymbolName
                        set lTclNetSymbolName [DboTclHelper_sGetConstCharPtr $lNetSymbolName]
                        #get wire connected to this offpage
                        set lWireObj [$lInst GetWire $lStatus]
                        if {[$lStatus OK] == 0} {
                            puts "Offpage instance $lTclNetSymbolName has no wire connected."
                            break
                        }
                        
                        set lAliasIter [$lWireObj NewAliasesIter $lStatus]
                        set lAlias [$lAliasIter NextAlias $lStatus]
                        set lAliasName [DboTclHelper_sMakeCString] 
                        #search all possible alias name of this wire
                        while {$lAlias!=$lNullObj} {
                            $lAlias GetName $lAliasName
                            set lTclAliasName [DboTclHelper_sGetConstCharPtr $lAliasName]
                            #we found a non NULL Alias
                            if {[string length $lTclAliasName]!=0} {
                                puts "Selected OffPage:$lTclNetSymbolName . Alias on NetSymbol:$lTclAliasName"
                                #If Alias differe from offpage Name value, then update NAME
                                if {[string compare $lTclAliasName $lTclNetSymbolName] != 0} {
                                    #set property = Name
                                    set lPropNameCStr [DboTclHelper_sMakeCString "Name"] 
                                    #Set name value to Alias name
                                    set lPropValueCStr $lAliasName
                                    #add or modify the offpage NAME property with value = Alias netname
                                    set lStatus [$lInst SetEffectivePropStringValue $lPropNameCStr $lPropValueCStr] 
                                    puts "$lTclNetSymbolName Changed to $lTclAliasName"
                                }
                                break
                            }
                            set lAlias [$lAliasIter NextAlias $lStatus]
                        }
    
                        ## Make sure offpage Name property is visible
                        # check offpage symbol and rotation-mirror state: to determine if the name label is on the left or right side
                        set keepposition 0
                        if {    (-1 != [string first "FAKELEFT" $symbolname_string]) ||\
                                (-1 != [string first "_RIGHT" $symbolname_string]) ||\
                                (-1 != [string first "OFFPAGELEFT-L" $symbolname_string] && $symb_mirror==0 && $symb_rotation==0) ||\
                                (-1 != [string first "OFFPAGELEFT-R" $symbolname_string] && $symb_mirror==1 && $symb_rotation==0) ||\
                                (-1 != [string first "OFFPAGELEFT-R" $symbolname_string] && $symb_mirror==0 && $symb_rotation==2) ||\
                                (-1 != [string first "OFFPAGEBI" $symbolname_string]     && $symb_mirror==0 && $symb_rotation==0) \
                                } {
                            ##set display parameters tailored for Source Symbol where label is on the right side
                            set rotation 0 
                            #set font parameters: Arial, 10 (size=6), remaining parameters unknown
                            set logfont [DboTclHelper_sMakeLOGFONT "Arial" 10 0 0 0 400 0 0 0 0 7 0 1 16]
                            set color $::DboValue_DEFAULT_OBJECT_COLOR 
                            set lX 15 
                            set lY 5 
                            set displocation [DboTclHelper_sMakeCPoint $lX $lY] 
                        } else {
                            if {    (-1 != [string first "FAKERIGHT" $symbolname_string]) ||\
                                    (-1 != [string first "_LEFT" $symbolname_string]) || \
                                    (-1 != [string first "OFFPAGELEFT-R" $symbolname_string] && $symb_mirror==0 && $symb_rotation==0) ||\
                                    (-1 != [string first "OFFPAGELEFT-L" $symbolname_string] && $symb_mirror==1 && $symb_rotation==0) ||\
                                    (-1 != [string first "OFFPAGELEFT-L" $symbolname_string] && $symb_mirror==0 && $symb_rotation==2) ||\
                                    (-1 != [string first "OFFPAGEBI" $symbolname_string]     && $symb_mirror==1 && $symb_rotation==0) ||\
                                    (-1 != [string first "OFFPAGEBI" $symbolname_string]     && $symb_mirror==0 && $symb_rotation==2) \
                                    } {
                                ##set display parameters tailored for Source Symbol where label is on the left side
                                #compute X position to compensate to text justification which is wrong and cannot be fixed
                                set proplen [string length $lTclAliasName]
                                set upper_val [string toupper $lTclAliasName] 
                                set offset -10
                                set idx 0
                                #compute string position based on each char width
                                while { ($idx < $proplen) }  {
                                    set lcar [string index $upper_val $idx]
                                    if {$lcar=="I" || $lcar=="1"} {
                                        #set a smaller offset for slim char
                                        set offset [expr $offset - 3]
                                    } else {
                                        #set a normal offset for all other char
                                        set offset [expr $offset - 5]
                                    }
                                    incr idx
                                }
                                ##display setting tailored for Source Symbol=__fakeRight_OffPage
                                set rotation 0 
                                #set font parameters: Arial, 10 (size=6), remaining parameters unknown
                                set logfont [DboTclHelper_sMakeLOGFONT "Arial" 10 0 0 0 400 0 0 0 0 7 0 1 16]
                                set color $::DboValue_DEFAULT_OBJECT_COLOR 
                                set lX $offset
                                set lY 5 
                                set displocation [DboTclHelper_sMakeCPoint $lX $lY]
                            } else {
                                #offpage is from central lib, unfortunately, label position cannot be predicted (for now)
                                ##use these default display parameters tailored for Source Symbol is from central lib
                                puts "OFFPAGE found that I dont know how to handle the text offset"
                                set rotation 0 
                                #set font parameters: Arial, 10 (size=6), remaining parameters unknown
                                set logfont [DboTclHelper_sMakeLOGFONT "Arial" 10 0 0 0 400 0 0 0 0 7 0 1 16]
                                set color $::DboValue_DEFAULT_OBJECT_COLOR 
                                set lX 15 
                                set lY 5 
                                set displocation [DboTclHelper_sMakeCPoint $lX $lY] 
                                set keepposition 1
                            }
                        }
                        #Visibility property only accessible thru Instance not occurrence
                        #attempt to get the handle to display property "NAME"
                        set lPropNameCStr [DboTclHelper_sMakeCString "NAME"] 
                        set pDispProp [$lInst GetDisplayProp $lPropNameCStr $lStatus] 
                        if { $pDispProp != $varNullObj } {
                            #visibility property exist, get what type was set
                            set prop_visi_type [$pDispProp GetDisplayType $lStatus]
                            if {$prop_visi_type != 0} {
                                #visi type was not invisible
                                #puts "Visibility was on, rewritten"
                                #set property as value visible
                                $pDispProp SetDisplayType $::DboValue_VALUE_ONLY
                                #update display location
                                if {$keepposition != 1} {
                                    $pDispProp SetLocation $displocation
                                }
                            } else {
                                #puts "Disp prop present but visibility off, make it visible"
                                #set property as value visible
                                $pDispProp SetDisplayType $::DboValue_VALUE_ONLY
                                #update display location
                                if {$keepposition != 1} {
                                    $pDispProp SetLocation $displocation
                                }
                            }
                        } else {
                            #Create display property
                            set pNewDispProp [$lInst NewDisplayProp $lStatus $lPropNameCStr $displocation $rotation $logfont $color] 
                            #set property as value visible
                            $pNewDispProp SetDisplayType $::DboValue_VALUE_ONLY  
                            #puts "no visibility was prop present, script added it"
                        }
                        
                    }
                }
             }
             #get the next part instance
             set lInst [$lOffpgInstsIter NextOffPageConnector  $lStatus]
         }  ;#while (lInst == ...)

         #delete place holder $lOffpgInstsIter
         delete_DboPageOffPageConnectorsIter $lOffpgInstsIter

         puts "Number of instances processed in this page: $inst_cnt"
         set total_inst [expr $total_inst + $inst_cnt]
         #get the next page object
         set lPage [$lPagesIter NextPage $lStatus]
    }  ;#while $lPage != $lNullObj
    #close schematic page iter mode, thus close also page iter mode
    delete_DboSchematicPagesIter $lPagesIter
    #close schematic view iter
    delete_DboLibViewsIter $lSchematicIter 

puts "\nScript done!\n"

## END OF THE SCRIPT ##

#source c:/otoimport/fix_offpages-test.tcl
